/***********************************************************************
 * Time-stamp: <Samstag, 12.05.2001, 16:41:28; edited by heiko>
 * 
 * Tina's random number generators
 *
 * diehard_file generates a binary input file for the diehard test
 * y Marsaglia; http://stat.fsu.edu/pub/diehard/
 *
 * Copyright by Heiko Bauke, Magdeburg 2001 
 *
 * heiko.bauke@student.uni-magdeburg.de
 *
 * This is free software. You may use and distribute this software under
 * the terms of the GNU GENERAL PUBLIC LICENSE Version 2. See COPYING
 * for details.
 *
 ***********************************************************************/

#include <cstdlib>
#include <iostream>
#include <fstream>
#include <new>
#include <string>
#include "trng.h"

using namespace TRNG;
using namespace std;


int main(void) {
  char c;
  RNG *r;
  string name;
  long i, split;
  unsigned long q;
  ofstream file;

  cout << "choose a pseudo random number generator\n\n";
  cout << "  a) ParkMiller\n";
  cout << "  b) RAND\n";
  cout << "  c) LCG64\n";
  cout << "  d) LMC2\n";
  cout << "  e) LMC3\n";
  cout << "  f) LMC4\n";
  cout << "  g) CLCG2\n";
  cout << "  h) CLCG3\n";
  cout << "  i) CLCG4\n";
  cout << "  j) EINV\n";
  cout << "  k) EINVLCG64\n\n";
  cin >> c;
  switch (c) {
      case 'a' : r=new ParkMiller; break;
      case 'b' : r=new RAND; break;
      case 'c' : r=new LCG64; break;
      case 'd' : r=new LMC2; break;
      case 'e' : r=new LMC3; break;
      case 'f' : r=new LMC4; break;
      case 'g' : r=new CLCG2; break;
      case 'h' : r=new CLCG3; break;
      case 'i' : r=new CLCG4; break;
      case 'j' : r=new EINV; break;
      case 'k' : r=new EINVLCG64; break;
      default : return(EXIT_FAILURE);
  }
  cout << "splitting level (>0): ";
  cin >> split;
  r->split(split, 0l);
  cout << "file name: ";
  cin >> name;
  file.open(name.c_str(), ios::out|ios::binary);
  for (i=0; i<2621440; ++i) {
    q=r->rand()*2l;
    file.write(reinterpret_cast<const char *>(&q), sizeof(q));
  }
  file.close();
  return(EXIT_SUCCESS);
}

